from discord import Member, Bot, Cog, ApplicationContext
from discord.commands import slash_command
from logging import Logger

from framework.redis import Redis


class Greetings(Cog):
    def __init__(self, bot: Bot, logger: Logger, redis: Redis):
        self.bot = bot
        self.logger = logger
        self.redis = redis

    @slash_command()
    async def redis_set(self, context: ApplicationContext, key: str, value: str):
        self.logger.info(f"redis set {value} at {key}")
        await self.redis.set(key, value)

        await context.respond(f"redis set {value} at {key}")

    @slash_command()
    async def redis_get(self, context: ApplicationContext, key: str):
        self.logger.info(f"redis get {key}")
        value = await self.redis.get(key)

        await context.respond(f"redis get {key}: {value}")
